function PreferencesMap(_1){
this.prefix=_1;
this.keyMap={};
this.count=0;
this.prefSize=0;
this.prefLimit=8192;
this._deserializeKeys();
};
function calcPreferenceEntrySize(_2,_3){
return _2.length*2+_3.toString().length;
};
PreferencesMap.prototype._deserializeKeys=function(){
this.keyMap={};
this.count=0;
this.prefSize=0;
var _4=widget.preferenceForKey(this.prefix+"_mapKeys");
if(!_4){
return;
}
var _5=_4.split(",");
for(var i=0;i<_5.length;i++){
var _7=_5[i];
var _8=_7.substring(this.prefix.length);
this.keyMap[_8]=true;
this.count++;
}
};
PreferencesMap.prototype._serializeKeys=function(){
var _9="";
for(var _a in this.keyMap){
if(!this.keyMap.hasOwnProperty(_a)){
continue;
}
if(_9.length>0){
_9+=",";
}
_9+=this.prefix+_a;
}
return _9;
};
PreferencesMap.prototype.size=function(){
return this.count;
};
PreferencesMap.prototype.dataSize=function(){
return this.prefSize;
};
PreferencesMap.prototype.put=function(_b,_c){
if(!this.tryPut(_b,_c)){
throw new Error("Memory limit reached. It is now: "+this.prefSize+"/"+this.prefLimit+", new entry size is: "+calcPreferenceEntrySize(this.prefix+_b,_c)+". Entry: "+this.name+" -> "+_c);
}
};
PreferencesMap.prototype.tryPut=function(_d,_e){
if(!_d){
throw new Error("Key must be non-null");
}
var _f=this.prefix+_d;
if(!_e){
PreferencesMap.log.debug("Putting a undefnied value. Removing it instead:"+_f);
this.remove(_d);
return true;
}
var _10=this.prefSize+calcPreferenceEntrySize(_f,_e);
if(_10>this.prefLimit){
return false;
}
this.keyMap[_d]=true;
this.count++;
this.prefSize+=calcPreferenceEntrySize(_f,_e);
widget.setPreferenceForKey(this._serializeKeys(),this.prefix+"_mapKeys");
widget.setPreferenceForKey(_e,_f);
return true;
};
PreferencesMap.prototype.get=function(_11){
var key=this.prefix+_11;
var val=widget.preferenceForKey(key);
return val?val:null;
};
PreferencesMap.prototype.keys=function(){
var ret=[];
var i=0;
for(var _16 in this.keyMap){
if(this.keyMap.hasOwnProperty(_16)){
ret[i++]=_16;
}
}
return ret;
};
PreferencesMap.prototype.clear=function(){
this.count=0;
this.prefSize=0;
for(var _17 in this.keyMap){
if(this.keyMap.hasOwnProperty(_17)){
widget.setPreferenceForKey("",this.prefix+_17);
}
}
this.keyMap={};
widget.setPreferenceForKey(this._serializeKeys(),this.prefix+"_mapKeys");
};
PreferencesMap.prototype.remove=function(_18){
var key=this.prefix+_18;
var old=widget.preferenceForKey(key);
if(!old){
var _1b=this.keyMap[_18];
delete this.keyMap[_18];
return null;
}
this.prefSize-=calcPreferenceEntrySize(key,old);
delete this.keyMap[_18];
widget.setPreferenceForKey(this._serializeKeys(),this.prefix+"_mapKeys");
widget.setPreferenceForKey("",key);
this.count--;
return old;
};
PreferencesMap.log=Logger.getLogger("PreferencesMap");
