function PhotoViewer(_1,id){
PhotoViewer.baseConstructor.call(this,id);
var _3=this;
this.reInsert=false;
var _4=_1.onActivated;
_1.onActivated=function(){
_4.call(_1);
_3.onActivated();
};
var _5=_1.onDeactivated;
_1.onDeactivated=function(){
_5.call(_1);
_3.onDeactivated();
};
this.table=$(this.id);
if(this.table.nodeName!="TABLE"){
throw new Error("PhotoViewer has to be of root element");
}
this.table.removeChildren();
var tr=document.createElement("tr");
var td=document.createElement("td");
td.style.textAlign="center";
td.style.verticalAlign="middle";
this.loader=$(document.createElement("div"));
this.loader.className="photo_view_loader hidden";
this.loader.innerHTML="<img src=\"images/loader.gif\" />";
td.appendChild(this.loader);
this.tagContainer=$(document.createElement("div"));
this.tagContainer.className="tag_container";
td.appendChild(this.tagContainer);
tr.appendChild(td);
this.table.appendChild(tr);
window.addEventListener("resize",function(){
_3.onResize();
},false);
};
Helper.extend(PhotoViewer,Container);
PhotoViewer.prototype.showImage=function(_8){
if(PhotoViewer.log.isDebugEnabled()){
PhotoViewer.log.debug("Start loading a new image: "+_8);
}
if(this.image){
if(this.image.parentNode){
this.tagContainer.removeChild(this.image);
}
this.image.onload=null;
this.image.onerror=null;
this.image.src=null;
this.image=null;
}
this.tmpImageSrc=null;
var _9=this;
this.image=$(document.createElement("img"));
this.image.onload=function(){
clearTimeout(this.loadTimerId);
_9._onImageLoaded();
};
this.image.onerror=function(){
clearTimeout(this.loadTimerId);
_9._onImageError();
};
this.image.onclick=function(e){
if(_9.onImageClicked){
_9.onImageClicked(e);
}
};
this.tagContainer.style.width=null;
this.tagContainer.style.height=null;
this.loader.show(true);
this.tagContainer.show(false);
this.image.src=_8;
if(!WrtHelper.isTouchEnabledDevice()){
this.image.loadTimerId=setTimeout(function(){
_9.image.onerror.call(_9.image);
},5000);
}
};
PhotoViewer.prototype._onImageLoaded=function(){
if(PhotoViewer.log.isDebugEnabled()){
PhotoViewer.log.debug("Successfully loaded image: "+this.image.src);
PhotoViewer.log.debug("Image size: "+this.image.width+","+this.image.height+"; container size: "+this.table.clientWidth+","+this.table.clientHeight);
}
if(WrtHelper.isTouchEnabledDevice()){
this._resizeAndAddForTouch();
}else{
this._resizeAndAddForNonTouch();
}
};
PhotoViewer.prototype._resizeAndAddForTouch=function(){
this.naturalSize={width:this.image.width,height:this.image.height};
var _b=this.resizeImage(this.naturalSize,{width:this.table.clientWidth,height:this.table.clientHeight});
this.image.width=_b.width;
this.image.height=_b.height;
this.tagContainer.appendChild(this.image);
this.loader.show(false);
this.tagContainer.show(true);
if(this.onImageLoaded){
this.onImageLoaded();
}
};
PhotoViewer.prototype._resizeAndAddForNonTouch=function(){
this.tagContainer.style.width="1px";
this.tagContainer.style.height="1px";
this.tagContainer.style.overflow="hidden";
this.tagContainer.appendChild(this.image);
this.tagContainer.show(true);
this.naturalSize={width:this.image.width,height:this.image.height};
var _c=this.resizeImage(this.naturalSize,{width:this.table.clientWidth,height:this.table.clientHeight});
this.image.width=_c.width;
this.image.height=_c.height;
this.loader.show(false);
this.tagContainer.style.width=null;
this.tagContainer.style.height=null;
this.tagContainer.style.overflow=null;
if(this.onImageLoaded){
this.onImageLoaded();
}
};
PhotoViewer.prototype._onImageError=function(){
PhotoViewer.log.error("Failed to load image");
if(this.image){
this.image.onload=null;
this.image.onerror=null;
}else{
this.image=$(document.createElement("img"));
}
this.image.src=PhotoViewer.ERROR_IMAGE_URL;
this.tagContainer.appendChild(this.image);
this.loader.show(false);
this.tagContainer.show(true);
if(this.onImageError){
this.onImageError();
}
};
PhotoViewer.prototype.getImageSrc=function(){
var _d=null;
if(this.image){
_d=this.image.src;
}
return _d;
};
PhotoViewer.prototype.getImageSize=function(){
var _e=null;
if(this.image){
_e={width:this.image.width,height:this.image.height};
}
return _e;
};
PhotoViewer.prototype.getOffsetSize=function(){
return {width:this.table.offsetWidth,height:this.table.offsetHeight};
};
PhotoViewer.prototype.getImageOffset=function(){
if(!this.image){
return null;
}
return {top:Math.max(this.image.offsetTop,this.tagContainer.offsetTop),left:Math.max(this.image.offsetLeft,this.tagContainer.offsetLeft)};
};
PhotoViewer.prototype.onResize=function(){
if(this.image){
var _f=this.image.style.display;
this.image.style.display="none";
var _10=this.resizeImage(this.naturalSize,{width:this.table.clientWidth,height:this.table.clientHeight});
this.image.width=_10.width;
this.image.height=_10.height;
this.image.style.display=_f;
}
};
PhotoViewer.prototype.onActivated=function(){
this.loader.show(true);
this.tagContainer.show(false);
if(this.tmpImageSrc){
if(PhotoViewer.log.isDebugEnabled()){
PhotoViewer.log.debug("onActivated with an existing image: "+this.tmpImageSrc);
}
this.showImage(this.tmpImageSrc);
this.tmpImageSrc=null;
this.reInsert=false;
}
};
PhotoViewer.prototype.onDeactivated=function(){
if(this.image){
try{
this.tagContainer.removeChild(this.image);
if(this.reInsert){
this.tmpImageSrc=this.image.src;
if(PhotoViewer.log.isDebugEnabled()){
PhotoViewer.log.debug("onDeactivated - remember the current image:"+this.tmpImageSrc);
}
}else{
this.tmpImageSrc=null;
}
this.image.onload=null;
this.image.onerror=null;
this.image.src=null;
this.image=null;
}
catch(e){
PhotoViewer.log.error("Failed to remove image from DOM on deactivation!");
this.image.onload=null;
this.image.onerror=null;
this.image.src=null;
this.image=null;
}
}
};
PhotoViewer.prototype.show=function(_11){
this.table.show(_11);
};
PhotoViewer.prototype.resizeImage=function(_12,_13){
var _14=1;
var _15=_12.width;
var _16=_12.height;
if(_12.width>_13.width){
_15=_13.width;
_14=parseInt(_13.width)/_12.width;
var _17=Math.round(_12.height*_14);
if(_17>_13.height){
_14=parseInt(_13.height)/_17;
_15=Math.round(_15*_14);
_16=Math.round(_17*_14);
}else{
_16=_17;
}
}else{
if(_12.height>_13.height){
_14=parseInt(_13.height)/_16;
_15=Math.round(_15*_14);
_16=Math.round(_16*_14);
}
}
return {width:_15,height:_16,factor:_14};
};
PhotoViewer.log=Logger.getLogger("PhotoViewer");
PhotoViewer.EMPTY_IMAGE_URL="images/image_empty.png";
PhotoViewer.ERROR_IMAGE_URL="images/image_error.png";
