function Container(id,_2){
this.id=id;
this.activeItem=null;
this.containers={};
this._isActive=false;
this.focusableItems=null;
this.items=new HashTable();
this.refreshTime=Container.REFRESH_TIME;
if(_2){
this.scroller=$(_2);
this.storedScrollerPos=0;
}
this._lastRefresh=0;
this.dirty=true;
this.veryDirty=false;
};
Container.prototype.addContainer=function(_3){
Container.log.info("Adding container "+_3.id);
this.containers[_3.id]=_3;
this.invalidate();
};
Container.prototype.removeContainer=function(_4){
Container.log.info("Removing container "+_4.id);
delete this.containers[_4.id];
this.invalidate();
};
Container.prototype.markDirty=function(_5){
this.dirty=true;
this.veryDirty=this.veryDirty||_5;
this._lastRefresh=0;
};
Container.prototype.needsRefresh=function(){
var _6=new Date().getTime();
return this.veryDirty||this.dirty||!this.refreshTime||_6-this._lastRefresh>this.refreshTime;
};
Container.prototype._refresh=function(){
var _7=this;
var _8=this.veryDirty;
this.veryDirty=false;
this.dirty=false;
setTimeout(function(){
_7.refresh(_8);
_7._lastRefresh=new Date().getTime();
},0);
};
Container.prototype.reset=function(){
this._lastRefresh=0;
this.invalidate();
};
Container.prototype.getContainers=function(){
var _9=[],_a=this.containers,_b;
for(_b in _a){
if(!_a.hasOwnProperty(_b)){
continue;
}
_9.push(_a[_b]);
}
return _9;
};
Container.prototype._createItem=function(id){
var _d=new Item(id);
this.items.put(_d.id,_d);
return _d;
};
Container.prototype.isVisible=function(){
var _e=$(this.id);
var _f=_e.className;
return !_f||!Container.HIDDEN_REG_EX.test(_f);
};
Container.prototype.remove=function(id,_11){
var _12=this.items.get(id);
if(_12!=null){
if(_12==this.activeItem){
if(_12.up){
this.activate(_12.up);
}else{
if(_12.down){
this.activate(_12.down);
}else{
if(_12.left){
this.activate(_12.left);
}else{
if(_12.right){
this.activate(_12.right);
}else{
this.updateElementSelectedStatus(this.activeItem.element,false);
this.activeItem=null;
}
}
}
}
}
if(_12.up&&_12.up.down){
_12.up.down=_12.down;
}
if(_12.down&&_12.down.up){
_12.down.up=_12.up;
}
if(_12.left&&_12.left.right){
_12.left.right=_12.right;
}
if(_12.right&&_12.right.left){
_12.right.left=_12.left;
}
this.items.remove(id);
if(_11==null||_11){
_12.element.parentNode.removeChild(_12.element);
}
}
};
Container.prototype.clear=function(_13){
var it=this.items.iterator();
while(it.hasNext()){
this.remove(it.key(),_13);
it=this.items.iterator();
}
this.invalidate();
};
Container.prototype.isActive=function(){
return this._isActive;
};
Container.prototype._processKeyEvent=function(_15){
if(_15.gainFocus&&this.selected){
return true;
}
if(this.isContainer(this.selected)&&this.containers[this.selected.id]._processKeyEvent(_15)){
return true;
}
var ret=false;
switch(_15.keyNum){
case Keyboard.KEY_LEFT:
ret=this.moveSelection(_15,Direction.LEFT);
break;
case Keyboard.KEY_RIGHT:
ret=this.moveSelection(_15,Direction.RIGHT);
break;
case Keyboard.KEY_UP:
ret=this.moveSelection(_15,Direction.UP);
break;
case Keyboard.KEY_DOWN:
ret=this.moveSelection(_15,Direction.DOWN);
break;
case Keyboard.KEY_ENTER:
ret=this.onEnterPressed(_15);
break;
}
return ret;
};
Container.prototype.getHTMLElement=function(){
return $(this.id);
};
function getElementId(_17){
return !_17?"null":_17.tagName+"["+_17.id+"] == "+_17.className;
};
Container.prototype.isContainer=function(obj){
return obj&&obj.id&&this.containers[obj.id];
};
Container.prototype.setSelected=function(_19,_1a,_1b){
if(this.selected===_19){
return;
}
var _1c=arguments.length===1||_1a;
var old=this.selected;
if(this.selected){
var sel=this.selected;
setTimeout(function(){
sel.blur();
},0);
$(this.selected).setClassName("focused",false);
}
if(_19){
$(_19).setClassName("focused",true);
_19.focus();
if(_19.tagName!=="SELECT"){
setTimeout(function(){
_19.blur();
},0);
}
if(_1c){
UIManager.ensureElementVisible(_19);
}
}
this.selected=_19;
if(this.selected){
Events.fireOnSelected(this.selected);
}
if(this.isContainer(old)){
Container.log.info("Container selected. id: "+old.id);
this.containers[old.id].onFocusLost();
}
if(this.isContainer(this.selected)){
Container.log.info("Container deselected. id: "+old.id);
this.containers[this.selected.id].onFocusGained();
}
this.onSelectionChanged(this,this.selected,old);
};
Container.prototype.getSelected=function(){
return this.selected;
};
Container.prototype.onSelectionChanged=function(_1f,_20,old){
if(this.parent&&this.parent.onSelectionChanged){
this.parent.onSelectionChanged(this,_20,old);
}
};
Container.prototype.onEnterPressed=function(_22){
var _23=this.getSelected();
var div=document.createElement("div");
var _25="none";
var _26;
if(_23){
_26=_23.tagName;
_25=_23.tagName+"->"+_23.id+"#"+_23.className;
}
if(!_23){
Container.log.warn("Enter pressed, but no selection");
return false;
}
if(_23&&Utils.isElementEditable(_23)){
if(this.scroller){
var _27=UIUtils.getElementBounds(this.scroller);
var pos=UIUtils.getElementBounds(_23);
if(pos.y-_27.y+pos.height+20>this.scroller.scrollTop+_27.height){
this.scroller.scrollTop+=Math.min(20,pos.y+pos.height+20-_27.height+_27.y);
}
}
this.selected.focus();
this.selected.blur();
this.selected.focus();
_22.preventDefault();
Events.stopPropagation(_22);
var _29=this.selected;
return true;
}
var _29=_23;
while(_29&&!_29.action){
_29=_29.parentNode;
}
if(_29&&_29.action){
setTimeout(function(){
_29.action.call(_29,_22,_29);
},0);
Events.stopPropagation(_22);
_22.preventDefault();
return true;
}else{
Container.log.warn("No click handler found on "+this.selected);
}
return false;
};
Container.prototype.getFocusableItems=function(){
if(this.focusableItems&&(!this.scroller||(this.scroller&&this.scroller.scrollHeight===this.lastScrollHeight))){
return {items:this.focusableItems,bounds:this.focusableItemsBounds};
}
Container.log.info("Rebuilding element cache.");
this.focusableItems=this.extractSelectableNodes();
this.focusableItemsBounds=UIUtils.getElementBounds(this.focusableItems);
if(this.scroller){
this.lastScrollHeight=this.scroller.scrollHeight;
}
return {items:this.focusableItems,bounds:this.focusableItemsBounds};
};
Container.prototype.invalidate=function(){
this.focusableItems=null;
this.focusableItemsBounds=null;
if(this.selected){
var _2a=UIUtils.getElementBounds(this.selected);
if(!_2a.x&&!_2a.y&&!_2a.height){
this.setSelected(null);
}
}
};
Container.prototype.onFocusLost=function(){
if(this.selected){
if(this.selected.tagName==="INPUT"||this.selected.tagName==="TEXTAREA"){
this.selected.blur();
}
$(this.selected).setClassName("focused",false);
$(this.selected).setClassName("inactive",true);
}
this.invalidate();
};
Container.prototype.onFocusGained=function(){
var sel=this.selected;
if(sel){
$(sel).setClassName("focused",true);
sel.setClassName("inactive",false);
if(sel.tagName==="INPUT"||sel.tagName==="TEXTAREA"){
sel.focus();
sel.blur();
}
}
this.invalidate();
};
Container.prototype.moveSelection=function(_2c,_2d){
var _2e=new Date().getTime();
var _2f=null;
var _30=this.getFocusableItems();
var _31=_30.items;
var _32=_30.bounds;
var _33=this.getSelected();
var _34;
if(!_33){
switch(_2d){
case Direction.UP:
_34={x:0,y:window.screen.height,width:0,height:0};
break;
case Direction.DOWN:
_34={x:0,y:0,width:0,height:0};
break;
case Direction.LEFT:
_34={x:0,y:window.screen.width,height:30,width:0};
break;
case Direction.RIGHT:
_34={x:0,y:0,height:30,width:0};
break;
}
}else{
_34=UIUtils.getElementBounds(_33);
}
switch(_2d){
case Direction.UP:
_2f=UIUtils.getFirstElementAbove(_33,_34,_31,_32);
break;
case Direction.DOWN:
_2f=UIUtils.getFirstElementBelow(_33,_34,_31,_32);
break;
case Direction.LEFT:
_2f=UIUtils.getFirstElementLeft(_33,_34,_31,_32);
break;
case Direction.RIGHT:
_2f=UIUtils.getFirstElementRight(_33,_34,_31,_32);
break;
default:
throw new Error("Invalid direction: "+_2d);
}
var ret=_2f!=null;
var _36=this.scroller;
if(_36&&(_2d===Direction.UP||_2d===Direction.DOWN)&&!(_2d===Direction.UP&&_36.scrollTop===0)&&!(_2d===Direction.DOWN&&_36.scrollTop+_36.clientHeight>=_36.scrollHeight)){
var _37=_36.offsetHeight;
var _32=UIUtils.getElementBounds(_36);
var _38,_39;
if(_2f){
_39=UIUtils.getElementBounds(_2f);
}else{
if(_2d===Direction.DOWN){
_39={x:0,y:_36.scrollHeight,height:3};
}else{
_39={x:0,y:0};
}
}
if(_33){
_38=UIUtils.getElementBounds(_33);
}else{
if(_2d===Direction.DOWN){
_38={x:0,y:0};
}else{
_38={x:0,y:_36.scrollHeight};
}
}
var _3a=false;
_39.y-=_32.y;
_38.y-=_32.y;
var _3b;
if(_2d===Direction.UP){
_3a=_39.y-_36.scrollTop>=_37;
}else{
_3a=_38.y+_38.height>_36.scrollTop+_37||_36.scrollTop+_37<_39.y-_39.height;
}
var _3c=true;
if(_2f){
if(_2d===Direction.UP){
if(_36.scrollTop>_39.y||_36.scrollTop+_37<_39.y){
_36.scrollTop=_39.y;
}
}else{
var my=_39.y+Math.min(_39.height,_37);
var msy=_36.scrollTop+_37;
if(my>msy){
var _3b=my-msy;
if(_3b>_37||(_33&&_38.height>_37&&_37-_3b<Container.SCROLL_INCREMENT)){
_3c=false;
_36.scrollTop+=Container.SCROLL_INCREMENT;
}else{
_36.scrollTop+=_3b;
}
}
}
}else{
if(_2d===Direction.UP&&_36.scrollTop>=0){
ret=_36.scrollTop>5;
_36.scrollTop-=Math.min(Container.SCROLL_INCREMENT,_36.scrollTop);
}else{
if(_2d===Direction.DOWN&&_36.scrollTop+_37<_36.scrollHeight){
var _3b=Math.min(_36.scrollHeight-_36.scrollTop-_37,Container.SCROLL_INCREMENT);
ret=_3b>5;
_36.scrollTop+=_3b;
}
}
}
if(_3c&&_2f){
this.setSelected(_2f,false);
}
}else{
if(_2f){
this.setSelected(_2f,false);
}
}
if(ret&&_2f&&this.isContainer(_2f)){
_2c.gainFocus=true;
this.containers[_2f.id]._processKeyEvent(_2c);
}
var end=new Date().getTime();
Container.log.info("Selection change took "+(end-_2e)+" ms. Selected item: "+getElementId(this.getSelected()));
return ret;
};
Container.prototype._updateScroller=function(key){
if(this.scroller==null){
return false;
}
if(this.scroller.clientHeight<this.activeItem.element.offsetHeight){
if(key==Keyboard.KEY_DOWN||key==Keyboard.KEY_RIGHT){
if(Container.log.isDebugEnabled()){
Container.log.debug("Scroller KEY_DOWN: scroller.clientHeight "+this.scroller.clientHeight+" this.activeItem.offsetHeight "+this.activeItem.element.offsetHeight);
}
if(this.scroller.clientHeight<this.activeItem.element.offsetHeight){
var _41=this.scroller.clientHeight+this.scroller.scrollTop;
var _42=this.activeItem.element.offsetTop+this.activeItem.element.offsetHeight;
if(Container.log.isDebugEnabled()){
Container.log.debug("Scroller KEY_DOWN: visibleBottom "+_41+" itemBottom "+_42);
}
if(_41<_42){
var _43=(key==Keyboard.KEY_DOWN)?Container.SCROLL_DELTA:this._getPageScrollSize();
var _44=this.scroller.scrollTop+_43;
if(_44>this.scroller.scrollHeight){
_44=this.scroller.scrollHeight;
}
this.scroller.scrollTop=_44;
return true;
}
}
}
if(key==Keyboard.KEY_UP||key==Keyboard.KEY_LEFT){
if(this.activeItem.element.offsetTop<this.scroller.scrollTop){
var _43=(key==Keyboard.KEY_UP)?Container.SCROLL_DELTA:this._getPageScrollSize();
var _44=this.scroller.scrollTop-_43;
if(_44<0){
_44=0;
}
this.scroller.scrollTop=_44;
return true;
}
}
}
if(key==Keyboard.KEY_UP&&this.activeItem&&this.activeItem.up==null){
if(this.activeItem.up==null){
this.scroller.scrollTop=0;
}
}
return false;
};
Container.prototype._getPageScrollSize=function(){
return Math.round(this.scroller.clientHeight*0.97);
};
Container.prototype.ensureVisible=function(_45){
if(this.scroller==null){
return;
}
if(_45==null){
return;
}
if(!isParentOf(_45.element,this.scroller)){
if(Container.log.isDebugEnabled()){
Container.log.debug("Scroller pane is ignoring activation event for "+_45.id+" since it is not placed in scroller element");
}
return;
}
if(this.scroller.clientHeight<_45.element.offsetHeight){
return;
}
var rv=this._calculateOffset(_45.element);
var _47=rv.element;
var _48=rv.offsetTop;
if(_48<this.scroller.scrollTop){
this.scroller.scrollTop=_48;
var _49=_47.offsetHeight-_47.clientHeight;
if(_49>0&&this.scroller.scrollTop>=_49){
if(Container.log.isDebugEnabled()){
Container.log.debug("Correcting scroller top for "+_49);
}
this.scroller.scrollTop-=_49;
}
}else{
var _4a=this.scroller.clientHeight+this.scroller.scrollTop;
var _4b=_48+_47.offsetHeight;
if(_4a<_4b){
this.scroller.scrollTop+=_4b-_4a;
}
}
};
Container.prototype._calculateOffset=function(_4c){
var _4d=0;
var tmp=_4c;
if(tmp.nodeName=="TR"&&tmp.firstChild!=null){
_4c=tmp.firstChild;
tmp=tmp.firstChild;
}
while(tmp!=null&&isParentOf(tmp,this.scroller)){
if(tmp.offsetTop){
_4d+=tmp.offsetTop;
}
tmp=tmp.offsetParent;
}
return {offsetTop:_4d,element:_4c};
};
Container.prototype.activate=function(_4f){
if(_4f==null){
if(Container.log.isDebugEnabled()){
Container.log.debug("Container "+this.id+": no relation for given key.");
}
return;
}
if(this.activeItem){
this.updateElementSelectedStatus(this.activeItem.element,false);
}
this.activeItem=_4f;
this.updateElementSelectedStatus(this.activeItem.element,true);
this.ensureVisible(_4f);
};
Container.prototype.updateElementSelectedStatus=function(_50,_51){
$(_50).setClassName(Container.ACTIVE_STYLE,_51);
};
Container.prototype.setScrollerPos=function(pos){
if(this.scroller){
this.scroller.scrollTop=pos;
}
};
Container.prototype.onActivated=function(){
if(this.scroller){
var _53=this.storedScrollerPos;
if(Container.log.isDebugEnabled()){
Container.log.debug("Restoring scroller pos for "+this.id+": "+_53);
}
this.scroller.scrollTop=_53;
}
this._isActive=true;
if(this.refresh){
var now=new Date().getTime();
if(this.needsRefresh()){
this._refresh();
}
}
};
Container.prototype.onDeactivated=function(){
if(this.scroller){
this.storedScrollerPos=this.scroller.scrollTop;
if(Container.log.isDebugEnabled()){
Container.log.debug("Saving scroller pos for "+this.id+": "+this.storedScrollerPos);
}
this.scroller.scrollTop=0;
}
this._isActive=false;
if(this.selected){
$(this.selected).setClassName("focused",false);
if(Utils.isElementEditable(this.selected)){
this.selected.blur();
}
}
this.invalidate();
};
Container.log=Logger.getLogger("Container");
Container.SCROLL_DELTA=20;
Container.ACTIVE_STYLE="activated";
Container.prototype.setTouchEnabled=function(_55){
this.add=Container._getAdd(_55);
};
Container.prototype.extractSelectableNodes=function(){
var _56=[$(this.id)];
var ret=[];
while(_56.length){
var _58=_56.pop();
var _59=_58.childNodes;
for(var i=0;i<_59.length;i++){
var _5b=_59[i];
if(_5b.nodeType!==1){
continue;
}
if((_5b.style.display=="none"||_5b.style.visibility=="hidden"||_5b.className.indexOf("hidden")>=0)){
continue;
}
if((_5b.offsetWidth===undefined&&_5b.offsetHeight===undefined)){
continue;
}
if(UIUtils.FOCUSABLE_REG_EX.test(_5b.className)){
ret.push(_5b);
if(_5b.id&&this.containers[_5b.id]){
continue;
}
}
if(_5b.hasChildNodes()){
_56.push(_5b);
}
}
}
return ret;
};
Container.prototype.setAction=function(_5c,_5d){
var _5e=this;
Events(_5c).setAction(function(){
_5d.apply(_5e,arguments);
});
};
Container.prototype.add=function(id,up,_61,_62,_63){
var _64=this._createItem(id);
var _65=this;
_64.element.onclick=function(_66){
_65.activate(_64);
_64._clicked(_66);
_66.cancelBubble=true;
};
return _64;
};
Container.HIDDEN_REG_EX=new RegExp("(^|\\s)hidden(\\s|$)");
Container.REFRESH_TIME=60*1000;
Container.SCROLL_INCREMENT=25;
