function UIManager(){
this.activePage=null;
this.menu=null;
this.menuActive=false;
this.pages=[];
this.keyCommands=[];
this.focusedContainer=null;
this.glassPane=null;
if(!UIManager.keyboardHooked){
UIManager.keyboardHooked=true;
this._hookKeyboard();
}
};
UIManager.prototype._hookKeyboard=function(){
document.addEventListener("keypress",function(_1){
return uiManager._processKeyEvent(_1);
},true);
};
UIManager.prototype.resetPages=function(){
for(var i in this.pages){
var _3=this.pages[i];
if(_3.reset){
_3.reset();
}
_3._lastRefresh=0;
}
};
UIManager.prototype.addCommand=function(_4){
this.keyCommands[_4.key]=_4;
};
UIManager.prototype.setMenu=function(_5){
this.menu=_5;
_5.parent=this;
};
UIManager.prototype.getMenu=function(){
return this.menu;
};
UIManager.prototype.setGlassPane=function(_6){
if(_6){
UIManager.log.debug("Glasspane set to "+_6.id);
}else{
UIManager.log.debug("Glasspane removed");
}
this.glassPane=_6;
};
UIManager.prototype.showMenu=function(_7){
if(_7==null){
_7=true;
}
if(this.menu&&this.menuActive!=_7){
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Update menu: "+_7);
}
this.menuActive=_7;
this.menu.show(_7);
if(this.menuActive){
this.menu.onActivated();
}else{
this.menu.onDeactivated();
}
}
};
UIManager.prototype.isMenuShown=function(){
return this.menuActive;
};
UIManager.prototype.add=function(_8){
this.pages[_8.id]=_8;
_8.parent=this;
return _8;
};
UIManager.prototype.get=function(_9){
return this.pages[_9];
};
UIManager.prototype.transition=function(_a,_b){
if(_b){
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Hiding page "+_b.id);
}
$(_b.id).show(false);
}
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Showing page "+_a.id);
}
$(_a.id).show(true);
};
UIManager.prototype.activate=function(id,_d){
UIManager.log.debug("Activating container: "+id+" with param: "+_d);
var _e=this.pages[id];
if(!_e){
UIManager.log.error("Page "+id+" does not exist!");
return;
}
if(this.activePage&&this.activePage.id==id){
if(this.activePage.refresh){
UIManager.log.info("Manual refresh for page "+id);
this.activePage.refresh(true);
}
return;
}
if(this.activePage){
UIManager.log.debug("Deactivating container: "+this.activePage.id);
this.activePage.onDeactivated(_d);
}
this.transition(_e,this.activePage);
this.activePage=_e;
if(this.onActivatePageChanged){
UIManager.log.debug("Notifying listeners on page activation change. ");
this.onActivatePageChanged(this.activePage);
}
UIManager.log.debug("Calling onActivated on "+this.activePage.id);
this.activePage.onActivated(_d);
if(this.menu&&this.menu.onActivatePageChanged){
UIManager.log.debug("Notifiying menu of container activation: ");
this.menu.onActivatePageChanged.call(this.menu,this.activePage);
}
this.setFocusedContainer(this.activePage);
this.activePage.invalidate();
setTimeout(onResize,0);
};
UIManager.prototype.onSelectionChanged=function(_f,_10,old){
if(this.focusedContainer!==_f){
this.setFocusedContainer(_f);
}
};
UIManager.prototype.setFocusedContainer=function(_12){
if(this.focusedContainer===_12){
return;
}
if(this.focusedContainer){
this.focusedContainer.onFocusLost();
}
this.focusedContainer=_12;
if(this.focusedContainer){
this.focusedContainer.onFocusGained();
}
};
UIManager.prototype._processKeyEvent=function(_13){
_13.keyNum=Keyboard.translateKey(_13);
switch(_13.keyNum){
case Keyboard.KEY_DOWN:
case Keyboard.KEY_UP:
_13.preventDefault();
break;
case Keyboard.KEY_LEFT:
case Keyboard.KEY_RIGHT:
var _14=true;
if(_13.target){
if(_13.target.nodeName==="TEXTAREA"){
_14=false;
}else{
if(_13.target.nodeName==="INPUT"){
_14=_13.target.type!=="password"&&_13.target.type!=="text";
}
}
}
if(_14){
_13.preventDefault();
}else{
return;
}
}
if(this.glassPane){
this.glassPane._processKeyEvent(_13);
return true;
}
if(!this.focusedContainer){
this.setFocusedContainer(this.activePage);
}
if(this.focusedContainer.isVisible()&&this.focusedContainer._processKeyEvent(_13)){
return true;
}
if(!this.menu||!this.menu.isVisible()){
return false;
}
var _15=$(this.activePage.id);
var _16=$(this.focusedContainer.id);
var _17=$(this.menu.id);
var _18=UIUtils.getNextElementForEvent(_13,[_15,_17],_16);
if(!_18&&_13.keyNum===Keyboard.KEY_LEFT){
var _19=[_15,_17];
var b1=UIUtils.getElementBounds(_16);
var _1b=UIUtils.getElementBounds(_19);
_18=UIUtils.getFirstElementAbove(_16,b1,_19,_1b);
}
if(_18!=null){
_13.gainFocus=true;
var _1c;
if(_18===_17){
_1c=this.menu;
}else{
_1c=this.activePage;
}
this.setFocusedContainer(_1c);
return this.focusedContainer._processKeyEvent(_13);
}
return false;
};
UIManager._calculateOffset=function(_1d,_1e){
var _1f=UIUtils.getElementBounds([_1d,_1e]);
return {offsetTop:_1f[0].y-_1f[1].y,offsetHeight:_1f[0].height};
};
UIManager._calculateOffset2=function(_20,_21){
var _22=0;
var _23=0;
if(_20.nodeName==="TR"){
var td=_20.firstChild;
while(td){
if(td.offsetHeight){
_23=Math.max(_23,td.offsetHeight);
}
td=td.nextSibling;
}
td=_20.firstChild;
while(td&&td.nodeName!=="TD"){
td=td.nextSibling;
}
if(td){
_20=td;
}
}else{
_23=_20.offsetHeight;
}
while(_20){
if(_20.offsetTop){
_22+=_20.offsetTop;
}
_20=_20.offsetParent;
}
_22-=_21.offsetTop;
return {offsetTop:_22,offsetHeight:_23};
};
UIManager.ensureElementVisible=function(_25){
var _26=UIUtils.getScrollableParent(_25);
if(_26===null){
return;
}
var rv=this._calculateOffset2(_25,_26);
if(rv.offsetTop<_26.scrollTop){
_26.scrollTop=Math.max(rv.offsetTop,0);
}else{
var _28=_26.clientHeight+_26.scrollTop;
var _29=rv.offsetTop+rv.offsetHeight;
if(_28<_29){
if(rv.offsetHeight>_26.clientHeight){
_26.scrollTop=rv.offsetTop;
}else{
_26.scrollTop+=_29-_28;
}
}
}
};
UIManager.log=Logger.getLogger("UIManager");
